/*
** Network Audio Front-End (netaudio)
** by Ken Hollis <khollis@bitgate.com>
**/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>

#include "netaudio.h"

void check_blanks(void)
{
    if (address == NULL)
	address = "127.0.0.1";

    if (bind_address == NULL)
	bind_address = "127.0.0.1";

    if (mode == 0) {
	if (!is_quiet)
	    fprintf(stderr, "netaudio: no mode specified - defaulting to --receive with no options.\n");

	mode = MODE_RECEIVE;
    }

    if (frame_size == 0)
	frame_size = 33;

    if (port == 0)
	port = 31337;

    if (bind_port == 0)
	bind_port = 31337;
}

int main(int argc, char *argv[])
{
    signal(SIGPIPE, SIG_IGN);

    address = NULL;
    bind_address = NULL;

    port = 0;
    bind_port = 0;
    mode = 0;
    frame_size = 0;
    is_verbose = 0;
    is_quiet = 0;
    is_http = 0;

    if (argc > 1)
	check_options(argc, argv);

    check_blanks();

    if (mode == MODE_RECEIVE) {
	if (!strcmp(address, "127.0.0.1"))
	    receive_loop();
	else
	    receive_connect();
    }

    if (mode == MODE_SEND)
	send_connect();

    if (mode == MODE_BROADCAST)
	broadcast_loop();

    return 0;
}
